package org.yaoqiang.bpmn.model.elements.activities;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.core.common.Expression;

/**
 * StandardLoopCharacteristics
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class StandardLoopCharacteristics extends LoopCharacteristics {

	private static final long serialVersionUID = 5992325980770349797L;

	public StandardLoopCharacteristics(XMLElement parent) {
		super(parent, "standardLoopCharacteristics");
	}

	protected void fillStructure() {
		XMLAttribute attrTestBefore = new XMLAttribute(this, "testBefore", Boolean.FALSE.toString());
		XMLAttribute attrLoopMaximum = new XMLAttribute(this, "loopMaximum");
		Expression refLoopCondition = new Expression(this, "loopCondition");

		super.fillStructure();
		add(attrTestBefore);
		add(attrLoopMaximum);
		add(refLoopCondition);
	}

}
