package org.yaoqiang.bpmn.model.elements.humaninteraction;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.activities.Task;
import org.yaoqiang.bpmn.model.elements.core.common.FlowElements;

/**
 * UserTask
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class UserTask extends Task {

	private static final long serialVersionUID = 4153834048038139465L;

	public UserTask(String name) {
		this((FlowElements) null);
		setName(name);
	}

	public UserTask(FlowElements parent) {
		super(parent, "userTask");
	}

	protected void fillStructure() {
		XMLAttribute attrImplementation = new XMLAttribute(this, "implementation", "##unspecified");
		Renderings refRenderings = new Renderings(this);

		super.fillStructure();
		add(attrImplementation);
		add(refRenderings);
	}

}
